c#define MATHEMATICAPRINT
c######################################################################
      subroutine ReHHH_atat(reHHH)
      implicit none
      integer i,j,k,i1,j1,k1,l,ischeme,izerodv1
      double precision renfin(6,6,6),regfac,ReHHHIN(6,6,6),ReHHH(6,6,6),MHp2
      double precision MW2,MZ2, A0k,pi,ass,ZG(6,6)
      double precision absM3, phiM3      
      double precision Qs
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
     
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double precision ZH5(5,5),ZH(6,6)
     
      double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
      
      double complex nZU(6,6)
      
      double precision nMSu(6)
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
      double precision absM1, absM2, absAu(3), absAd(3), absAe(3),  
     &                 ml2(3), mer2(3), mq2(3), mdr2(3), mur2(3)      
      double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3)
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      logical CPcon,MHpmInput,onelswitch,mQrun

      double complex IC,ZUN(2,2),AT,la,Ala,ka,Aka,MUE,expETA,expVS,expM3
      common /gluino/ absM3,phiM3      
      common /scale/ Qs
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU
      common /nSu/ nMSu,nZU
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
      common /softbreak/ absM1, absM2, absAu, absAd, absAe,  
     &                   ml2, mer2, mq2, mdr2, mur2
      common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common /switch/ MHpmInput,CPcon,mQrun,onelswitch
      IC=dcmplx(0,1D0)
      ZUN(1:2,1:2) = nZU(5:6,5:6)
      MW2=Mw**2; MZ2=Mz**2;MHp2=MHpm**2
      Ala= absAlambda*(cos(phiAl) + IC*Sin(phiAl))
      AT= absAu(3)*(cos(phiAu(3)) + IC*Sin(phiAu(3)))
      la= abslambda*(Cos(phil) + IC*Sin(phil))
      ka= abskappa*(Cos(phik) + IC*Sin(phik))
      Aka=absAkappa*(Cos(phiAk) + IC*Sin(phiAk))
      expvs=(Cos(phis) + IC*Sin(phis))
      expETA=(Cos(phiu) + IC*Sin(phiu))
      MUE=vs*la*expvS/dsqrt(2d0)
      expM3=sqrt((Cos(phiM3) + IC*Sin(phiM3)) )
      pi= 4D0*atan(1D0)
      ass=g3**2/4./pi
      if(mQrun)then
        ischeme=1
      else
        ischeme=3
      endif
#ifdef MATHEMATICAPRINT
      OPEN(16,FILE='slha_test.dat', STATUS= 'UNKNOWN')
#endif      
     
      call trilinearHHH_atat(Qs**2,mt,MHp2,v,vS,Tanb,MW2,MZ2,
     -   nMSu(5),nMSu(6),ZUN,AT,MUE,Ala,ka,Aka,expETA,expvS,
     -   ReHHHIN,MQrun,MHpmInput)
c move from basis (hd,hu,hs,ad,au,as) to basis (a,as,hd,hu,hs,G) by rotation matrix ZG
      ZG=0D0
      ZG(1,4)=Sin(beta); ZG(1,5)=Cos(beta); ZG(2,6)=1D0; ZG(3,1)=1D0;
      ZG(4,2)=1D0; ZG(5,3)=1D0; ZG(6,4)=Cos(beta); ZG(6,5)=-Sin(beta)
      do i=1,6
      do j=1,6
      do k=1,6
      reHHH(i,j,k) =0D0
       do i1=1,6
       do j1=1,6
       do k1=1,6
      reHHH(i,j,k) = reHHH(i,j,k)+ZG(i,i1)*ZG(j,j1)*ZG(k,k1)*ReHHHIN(i1,j1,k1)
       enddo
       enddo
       enddo
      enddo
      enddo
      enddo
      end subroutine ReHHH_atat
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      
      subroutine trilinearHHH_atat(Q2N,MTN,MHpm2N,vvN,vSN,TBN,
     -   MW2N,MZ2N,MST1,MST2,ZUN,ATN,MUEN,AlaN,kaN,AKaN,expETAN,expvSN,
     -   reHHH,MQrun,MHpmInput)
      implicit none
      integer i,j,l,k,gen2,Gen3,Gen4,Gen5,Gen6,h1,ierror
      double precision reHHH(6,6,6),self(6,6),dMH2MT4(6,6),
     .     aTad(6),selfCT(6,6),TadCT(6),CHselfCT,
     .     selfIN(6,6),selfCTIN(6,6),selfINS(6,6),CHSELF,SCH_atat(2,2)

      double precision Q2N,MTN,MSt1,MSt2,MHpm2N,vvN,vSN,TBN,MW2N,MZ2N,
     .     S2B,C2B,dmsq4fin,dmsur4fin

      double complex ATN,ZUN(2,2),MUEN,expETAN,expvSN,dAt4fin
      double complex laN,AlaN,kaN,AKaN
      logical MHpmInput,mQrun
#include "TLMT4.h"
#include "HHH-decl.h"
c#include "TLCL.h"

      call couplingsEW(Q2N,MTN,MHpm2N,vvN,vSN,TBN,
     -   MW2N,MZ2N,MST1,MST2,ZUN,ATN,MUEN,expETAN,expvSN)

      MassHpm(1)=0D0
      MassHpm(2)=Sqrt(MHpm2N)
      S2B = 2*TB*CB2;          C2B= (CB - SB)*(CB + SB) 
      call LIBLOOP_atat()        
      call LIBLOOP_HHH_atat 
c one-loop counterterms            
      call CT1loopMT4(MQrun,dmsq4fin,dmsur4fin,dat4fin)
c two-loop counterterms
      call CT2loopMT4(selfCT,CHselfCT,TadCT)           
      call HHH_genuine_atat(reHHH)
      
      end 
       
                
c*
c----------------------------------------------------------------------
c*
      subroutine  LIBLOOP_HHH_atat
      implicit none
      integer i,j,k,gen3,gen4,gen5,h1
      double precision A0T,AEpT,B0T,BEpT,C0T,CEpT,
     .     a0th,aeth,M24,M44,mahs,FDMH(4,2,2),I0A,
     .     D0T,DEpT
      double complex K0T0      
#include "TLMT4.h"
#include "HHH-decl.h"  
       MassHpm2(1:2)=MassHpm(1:2)**2
       aC0TT3= C0T(M12,M12,M12,Q2)
       aCepTT3= CEpT(M12,M12,M12,Q2)       
       aD0TT4= D0T(M12,M12,M12,M12,Q2)
       aDEpTT4= DEpT(M12,M12,M12,M12,Q2)       

       do ISt4=1,2
       do ISt5=1,2
       do ISt6=1,2
       do ISt7=1,2
        aD0T(ISt4,ISt5,ISt6,ISt7)= D0T(MassSU2(IST4),MassSU2(IST5),
     .         MassSU2(IST6),MassSU2(IST7),Q2)
        aDEpT(ISt4,ISt5,ISt6,ISt7)= DEpT(MassSU2(IST4),MassSU2(IST5),
     .         MassSU2(IST6),MassSU2(IST7),Q2)
       enddo 
       enddo 
       enddo 
       enddo         
       
       Do ISt4=1,2
       Do ISt5=1,2
       Do INH4=1,6
         call FD111C(MassSU2(ISt4),MassSU2(ISt5),Mah2(INH4),aA0tN(ISt4),aA0tN(ISt5),
     -       a0tNH(INH4),aAetN(ISt4),aAetN(ISt5),aetNH(INH4),Q2,FD111STSTH3(1:10,ISt4, ISt5, INH4),0)
       enddo 
       enddo 
       enddo 
       Do ISt4=1,2
       Do ISt5=1,2
       Do INH4=1,6
         call FD211C(MassSU2(ISt4),MassSU2(ISt5),Mah2(INH4),aA0tN(ISt4),aA0tN(ISt5),
     - a0tNH(INH4),aAetN(ISt4),aAetN(ISt5),aetNH(INH4),Q2,FD211STSTH3(1:10,ISt4, ISt5, INH4),0)
       enddo 
       enddo 
       enddo 
       Do ISt4=1,2
       Do ISt5=1,2
       Do INH4=1,6
         call FD221C(MassSU2(ISt4),MassSU2(ISt5),Mah2(INH4),aA0tN(ISt4),aA0tN(ISt5),a0tNH(INH4),
     - aAetN(ISt4),aAetN(ISt5),aetNH(INH4),Q2,FD221STSTH3(1:10,ISt4, ISt5, INH4),0)
       enddo 
       enddo 
       enddo 
       Do INH4=1,6
         call FD321C(M12,M12,Mah2(INH4),a0t1,a0t1,a0tNH(INH4),aet1,aet1,aetNH(INH4),
     - Q2,FD321TTH3(1:10,INH4),0)
       enddo 

       Do ISt4=1,2
       Do INe4=1,3
         call FD311C(M12,MassSU2(ISt4),Mneu2(INe4),a0t1,aA0tN(ISt4),a0tNeu(INe4),aet1,
     - aAetN(ISt4),aetNeu(INe4),Q2,FD311TSTChi3(1:10,ISt4, INe4),0)
       enddo 
       enddo 
       Do ISt4=1,2
       Do INe4=1,3
         call FD321C(M12,MassSU2(ISt4),Mneu2(INe4),a0t1,aA0tN(ISt4),a0tNeu(INe4),aet1,
     - aAetN(ISt4),aetNeu(INe4),Q2,FD321TSTChi3(1:10,ISt4, INe4),0)
       enddo 
       enddo 
       Do ISt4=1,2
       Do INe4=1,3
         call FD211C(M12,MassSU2(ISt4),Mneu2(INe4),a0t1,aA0tN(ISt4),a0tNeu(INe4),aet1,
     - aAetN(ISt4),aetNeu(INe4),Q2,FD211TSTChi3(1:10,ISt4, INe4),0)
       enddo 
       enddo 
       Do ISt4=1,2
       Do INe4=1,3
         call FD321C(MassSU2(ISt4),M12,Mneu2(INe4),aA0tN(ISt4),a0t1,a0tNeu(INe4),aAetN(ISt4),
     - aet1,aetNeu(INe4),Q2,FD321STTChi3(1:10,ISt4, INe4),0)
       enddo 
       enddo 
       Do ISt4=1,2
       Do INe4=1,3
         call FD221C(M12,MassSU2(ISt4),Mneu2(INe4),a0t1,aA0tN(ISt4),a0tNeu(INe4),aet1,
     - aAetN(ISt4),aetNeu(INe4),Q2,FD221TSTChi3(1:10,ISt4, INe4),0)
       enddo 
       enddo 
       Do ISt5=1,2
       Do ISt4=1,2
       Do INH4=1,6
         call FD311C(MassSU2(ISt5),MassSU2(ISt4),Mah2(INH4),aA0tN(ISt5),aA0tN(ISt4),
     - a0tNH(INH4),aAetN(ISt5),aAetN(ISt4),aetNH(INH4),Q2,FD311STSTH3(1:10,ISt5, ISt4, INH4),0)
       enddo 
       enddo 
       enddo 
       Do ISt5=1,2
       Do ISt4=1,2
       Do INH4=1,6
         call FD321C(MassSU2(ISt5),MassSU2(ISt4),Mah2(INH4),aA0tN(ISt5),aA0tN(ISt4),a0tNH(INH4),
     - aAetN(ISt5),aAetN(ISt4),aetNH(INH4),Q2,FD321STSTH3(1:10,ISt5, ISt4, INH4),0)
       enddo 
       enddo 
       enddo 
       Do ISt4=1,2
       Do INH4=1,6
       Do ISt6=1,2
         call FD311C(MassSU2(ISt4),Mah2(INH4),MassSU2(ISt6),aA0tN(ISt4),a0tNH(INH4),aA0tN(ISt6),
     - aAetN(ISt4),aetNH(INH4),aAetN(ISt6),Q2,FD311STHST3(1:10,ISt4, INH4, ISt6),0)
       enddo 
       enddo 
       enddo 
       Do ISt4=1,2
       Do ICH4=1,2
         call FD311C(MassSU2(ISt4),MassHpm2(ICH4),MSQ2,aA0tN(ISt4),a0tHpN(ICH4),a0t5,aAetN(ISt4),
     - aetHpN(ICH4),aet5,Q2,FD311STHpSB3(1:10,ISt4, ICH4),0)
       enddo 
       enddo 

       Do ISt4=1,2
       Do INe4=1,3
         call FD111C(M12,MassSU2(ISt4),Mneu2(INe4),a0t1,aA0tN(ISt4),a0tNeu(INe4),aet1,aAetN(ISt4),
     - aetNeu(INe4),Q2,FD111TSTChi3(1:10,ISt4, INe4),0)
       enddo 
       enddo 
       Do ISt4=1,2
       Do INe4=1,3
         call FD111C(MassSU2(ISt4),Mneu2(INe4),M12,aA0tN(ISt4),a0tNeu(INe4),a0t1,aAetN(ISt4),
     - aetNeu(INe4),aet1,Q2,FD111STChiT3(1:10,ISt4, INe4),0)
       enddo 
       enddo 
       Do ISt4=1,2
       Do INe4=1,3
         call FD311C(MassSU2(ISt4),M12,Mneu2(INe4),aA0tN(ISt4),a0t1,a0tNeu(INe4),aAetN(ISt4),
     - aet1,aetNeu(INe4),Q2,FD311STTChi3(1:10,ISt4, INe4),0)
       enddo 
       enddo 
       Do ISt4=1,2
       Do INe4=1,3
         call FD211C(MassSU2(ISt4),M12,Mneu2(INe4),aA0tN(ISt4),a0t1,a0tNeu(INe4),aAetN(ISt4),
     - aet1,aetNeu(INe4),Q2,FD211STTChi3(1:10,ISt4, INe4),0)
       enddo 
       enddo 
       Do ISt4=1,2
         call FD111C(MassSU2(ISt4),MCha2,0D0,aA0tN(ISt4),a0tcha,0D0,aAetN(ISt4),aetcha,0D0,Q2,
     - FD111STChaB3(1:10,ISt4),0)
       enddo 
       Do ISt4=1,2
         call FD111C(0,MassSU2(ISt4),MCha2,0D0,aA0tN(ISt4),a0tcha,0D0,aAetN(ISt4),aetcha,Q2,
     - FD111BSTCha3(1:10,ISt4),0)
       enddo 
       Do ISt4=1,2
         call FD311C(MassSU2(ISt4),0D0,MCha2,aA0tN(ISt4),0D0,a0tcha,aAetN(ISt4),0D0,aetcha,Q2,
     - FD311STBCha3(1:10,ISt4),0)
       enddo 
       Do ISt4=1,2
         call FD211C(MassSU2(ISt4),0D0,MCha2,aA0tN(ISt4),0D0,a0tcha,aAetN(ISt4),0D0,aetcha,Q2,
     - FD211STBCha3(1:10,ISt4),0)
       enddo 
       Do INe4=1,3
       Do ISt4=1,2
         call FD211C(M12,Mneu2(INe4),MassSU2(ISt4),a0t1,a0tNeu(INe4),aA0tN(ISt4),aet1,aetNeu(INe4),
     - aAetN(ISt4),Q2,FD211TChiST3(1:10,INe4, ISt4),0)
       enddo 
       enddo 
       Do INH4=1,6
       Do ISt4=1,2
       Do ISt6=1,2
         call FD111C(Mah2(INH4),MassSU2(ISt4),MassSU2(ISt6),a0tNH(INH4),aA0tN(ISt4),aA0tN(ISt6),
     - aetNH(INH4),aAetN(ISt4),aAetN(ISt6),Q2,FD111HSTST3(1:10,INH4, ISt4, ISt6),0)
       enddo 
       enddo 
       enddo 
       Do ISt4=1,2
       Do INH4=1,6
       Do ISt6=1,2
         call FD211C(MassSU2(ISt4),Mah2(INH4),MassSU2(ISt6),aA0tN(ISt4),a0tNH(INH4),aA0tN(ISt6),
     - aAetN(ISt4),aetNH(INH4),aAetN(ISt6),Q2,FD211STHST3(1:10,ISt4, INH4, ISt6),0)
       enddo 
       enddo 
       enddo 
       Do INH4=1,6
         call FD411C(M12,M12,Mah2(INH4),a0t1,a0t1,a0tNH(INH4),aet1,aet1,aetNH(INH4),Q2,
     - FD411TTH3(1:10,INH4),0)
       enddo 
       Do ICH4=1,2
         call FD411C(M12,0D0,MassHpm2(ICH4),a0t1,0D0,a0tHpN(ICH4),aet1,0D0,aetHpN(ICH4),Q2,
     - FD411TBHp3(1:10,ICH4),0)
       enddo 
       Do INe4=1,3
       Do ISt4=1,2
         call FD411C(M12,Mneu2(INe4),MassSU2(ISt4),a0t1,a0tNeu(INe4),aA0tN(ISt4),aet1,aetNeu(INe4),
     - aAetN(ISt4),Q2,FD411TChiST3(1:10,INe4, ISt4),0)
       enddo 
       enddo 
         call FD411C(M12,MCha2,MSQ2,a0t1,a0tcha,a0t5,aet1,aetcha,aet5,Q2,FD411TChaSB3(1:10),0)
       Do INe4=1,3
       Do ISt4=1,2
         call FD111C(Mneu2(INe4),M12,MassSU2(ISt4),a0tNeu(INe4),a0t1,aA0tN(ISt4),aetNeu(INe4),aet1,
     - aAetN(ISt4),Q2,FD111ChiTST3(1:10,INe4, ISt4),0)
       enddo 
       enddo 
       Do ISt4=1,2
       Do INe4=1,3
         call FD411C(MassSU2(ISt4),M12,Mneu2(INe4),aA0tN(ISt4),a0t1,a0tNeu(INe4),aAetN(ISt4),aet1,
     - aetNeu(INe4),Q2,FD411STTChi3(1:10,ISt4, INe4),0)
       enddo 
       enddo 
       Do ISt4=1,2
         call FD111C(MCha2,0D0,MassSU2(ISt4),a0tcha,0D0,aA0tN(ISt4),aetcha,0D0,aAetN(ISt4),Q2,
     - FD111ChaBST3(1:10,ISt4),0)
       enddo 
       Do ISt4=1,2
         call FD411C(MassSU2(ISt4),0D0,MCha2,aA0tN(ISt4),0D0,a0tcha,aAetN(ISt4),0D0,aetcha,Q2,
     - FD411STBCha3(1:10,ISt4),0)
       enddo 
       Do ISt4=1,2
       Do INH4=1,6
       Do ISt6=1,2
         call FD411C(MassSU2(ISt4),Mah2(INH4),MassSU2(ISt6),aA0tN(ISt4),a0tNH(INH4),aA0tN(ISt6),
     - aAetN(ISt4),aetNH(INH4),aAetN(ISt6),Q2,FD411STHST3(1:10,ISt4, INH4, ISt6),0)
       enddo 
       enddo 
       enddo 
       Do ICH4=1,2
       Do ISt4=1,2
         call FD111C(MassHpm2(ICH4),MassSU2(ISt4),MSQ2,a0tHpN(ICH4),aA0tN(ISt4),a0t5,aetHpN(ICH4),
     - aAetN(ISt4),aet5,Q2,FD111HpSTSB3(1:10,ICH4, ISt4),0)
       enddo 
       enddo 
       Do ISt4=1,2
       Do ICH4=1,2
         call FD211C(MassSU2(ISt4),MassHpm2(ICH4),MSQ2,aA0tN(ISt4),a0tHpN(ICH4),a0t5,aAetN(ISt4),
     - aetHpN(ICH4),aet5,Q2,FD211STHpSB3(1:10,ISt4, ICH4),0)
       enddo 
       enddo 


              
       Do ISt4=1,2
       Do ICH4=1,2
         call FD411C(MassSU2(ISt4),MassHpm2(ICH4),MSQ2,aA0tN(ISt4),a0tHpN(ICH4),a0t5,aAetN(ISt4),
     - aetHpN(ICH4),aet5,Q2,FD411STHpSB3(1:10,ISt4, ICH4),0)
       enddo 
       enddo  

       Do ISt4=1,2
         call FD111C(MCha**2,MassSu(ISt4)**2,0D0,a0tcha,aA0tN(ISt4),0D0,aetcha,
     &   aAetN(ISt4),0D0,Q2,FD111ChaSTB3(1:10,ISt4),0)
       enddo 

      end subroutine  LIBLOOP_HHH_atat 
