c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      subroutine CALC_AMMS(slhafile)
cslhafile      
      implicit none
      
      character*30 slhafile
      

      double precision dAMM_gamH0_m(4),dAMM_gamH0_e(4)
      double precision dAMM_one_m,dAMM_two_m,dAMM_one_e,dAMM_two_e
      
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
      double precision absM1, absM2, absAu(3), absAd(3), absAe(3),  
     &                 ml2(3), mer2(3), mq2(3), mdr2(3), mur2(3)
      double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3)
      double precision absM3,phiM3
      double precision ZH5(5,5),ZH(6,6)
      double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      double complex CLChiFeSe(5,2),CRChiFeSe(5,2),CLChiFdSd(5,4),
     &               CRChiFdSd(5,4),CLChiFuSu(5,2),CRChiFuSu(5,2),
     &               ChStauStau(5,2,2),ChSbSb(5,2,2),ChStSt(5,2,2),
     &               CShChaCha(5,2,2),CPhChaCha(5,2,2)
      double precision CSfdown(5),CPfdown(5),CSfup(5),CPfup(5)
      double complex  CPHpChiCha(5,2),CSHpChiCha(5,2),CLWChiCha(5,2),
     &                 CRWChiCha(5,2),CPHpud(2),CSHpud(2),CSHpve,CPHpve 
      double complex CLChaFdSu(2,4),CRChaFdSu(2,4),CLChaFuSd(2,2),
     &               CRChaFuSd(2,2),CLChaFeSv(2),CRChaFeSv(2),
     &               CLdFgSd(2),CRdFgSd(2),CRuFgSu(2),CLuFgSu(2),
     &               CLbFgSb(2),CRbFgSb(2),CRtFgSt(2),CLtFgSt(2),
     &               CLsFgSs(2),CRsFgSs(2)
      double complex vZuu,aZuu,vZdd,aZdd,vZee,aZee,vZchacha(2,2),
     &               aZchacha(2,2)
      double precision C4de,C4se,C4be,C4bd,C4ge,C4ec,C4et,C4dd,
     &                      C4ds
      double complex convfac
      double precision kap,MSvtemp(2)
      double complex CLChaFeSvtemp(2,2),CRChaFeSvtemp(2,2)
      
      double precision resAMM_m(5),resEDM_m(5)
      double precision resAMM_e(5),resEDM_e(5)      
      integer ivegas(4),iprint
      character*7 folder
      character*30 filename
      double precision phase
      integer countvalid,EDMswitch
      double precision runm_hdec,alphas_hdec
      double precision Qs,mtMS,mbMS,mtDR,mbDR,a_sDR
      integer i
      
      double precision pi
      parameter (pi = 2d0*Asin(1d0))
      
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
      common /softbreak/ absM1, absM2, absAu, absAd, absAe,  
     &                   ml2, mer2, mq2, mdr2, mur2
      common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe
      common /gluino/ absM3,phiM3
      common/ couplingsEDM / CLChiFeSe,CRChiFeSe,CLChiFdSd,CRChiFdSd,
     &                       CLChiFuSu,CRChiFuSu,ChStauStau,ChSbSb,
     &                       ChStSt,CShChaCha,CPhChaCha,CSHpChiCha,
     &                       CPHpChiCha,CLWChiCha,CRWChiCha,
     &                       CSfdown,CPfdown,CSfup,CPfup,
     &                       CPHpud,CSHpud,CSHpve,CPHpve,
     &                       CLChaFdSu,CRChaFdSu,CLChaFuSd,CRChaFuSd,
     &                       CLChaFeSv,CRChaFeSv,CLdFgSd,CRdFgSd,
     &                       CRuFgSu,CLuFgSu,CLbFgSb,CRbFgSb,
     &                       CRtFgSt,CLtFgSt,CLsFgSs,CRsFgSs
      common/ couplingsEDM2/ vZuu,aZuu,vZdd,aZdd,vZee,aZee,vZchacha,
     &                       aZchacha 
      common/fourfermionop/ C4de,C4se,C4be,C4bd,C4ge,C4ec,C4et,C4dd,
     &                      C4ds
      common/inpVEGAS/ivegas,iprint
      common/checkvalid/countvalid
      common /EDMselec/ EDMswitch
      integer N0,Nloop,AMMswitch
      double precision XLAMBDA,AMC0,AMB0,AMT0,acc,xitla_hdec
      COMMON/ALS_HDEC/XLAMBDA,AMC0,AMB0,AMT0,N0 
      double precision agf,alph,amtau,ammuon,amz,amw 
      common/param_hdec/agf,alph,amtau,ammuon,amz,amw  
      double precision AMSB,AMS,AMC,AMB,AMT 
      COMMON/STRANGE_HDEC/AMSB  
      COMMON/MASSES_HDEC/AMS,AMC,AMB,AMT    
      logical isstrue
      common/issswitch/isstrue 
      common /AMMselec/ AMMswitch                      
! EDMs need to be evaluated at the EW scale: evolve quark masses to that scale 
      ams=ms
      amc=mc
      amb=mb
      amt=mt
      AMSB=ms 
      amz=MZ
      amc0=mc
      amb0=mb
      amt0=mt
      acc=1.d-8
      nloop=3
      xlambda=xitla_hdec(nloop,alphas,acc)

      n0=5
      call alsini_hdec(acc)     
      g3=sqrt(alphas_hdec(Mz,3)*4d0*pi)
     
      ms=runm_hdec(Mz,3)
      mc=runm_hdec(Mz,4)
      mb=runm_hdec(Mz,5)
      mt=runm_hdec(Mz,6)
     
      Yu(1) = mu*sqrt(2d0)/v/Sin(beta)
      Yu(2) = mc*sqrt(2d0)/v/Sin(beta)
      Yu(3) = mt*sqrt(2d0)/v/Sin(beta)
      Yd(1) = md*sqrt(2d0)/v/Cos(beta)
      Yd(2) = ms*sqrt(2d0)/v/Cos(beta)
      Yd(3) = mb*sqrt(2d0)/v/Cos(beta)
      
      call dsquarkmasses(g1,g2,v,beta,abslambda,vs,phil,phis,phiu,phiAd,
     &                   absAd,mq2,mdr2,Yd,MSd,ZD)
         
      call usquarkmasses(g1,g2,v,beta,abslambda,vs,phil,phis,phiu,phiAu,
     &                   absAu,mq2,mur2,Yu,MSu,ZU)
     
! recalcuate the necessary couplings at the EW scale
      call couplings
      call EDM_couplings
      iprint=0
      ivegas(1)=1000
      ivegas(2)=5
      ivegas(3)=2000
      ivegas(4)=5

      call RSTART(12,34,56,78)      

      call AMM_dEf_one(2,resAMM_m,resEDM_m)   
      call AMM_dEf_one(1,resAMM_e,resEDM_e)          
 


! calculate two-loop contributions to AMM of muon
      Qs=Sqrt(Sqrt(mer2(2)*ml2(2)))
      call AMM_dEf_gamH0(CSfdown,CPfdown,mmu,-1d0,dAMM_gamH0_m)
      dAMM_one_m=resAMM_m(1)+resAMM_m(2)+resAMM_m(3)+resAMM_m(4)+resAMM_m(5)
      dAMM_two_m=dAMM_gamH0_m(1)+dAMM_gamH0_m(2)
     &          +dAMM_gamH0_m(3)+dAMM_gamH0_m(4)
     &          + (-4*alpha)*dAMM_one_m*Log(Qs/mmu)

! calculate two-loop contributions to AMM of electron
      call AMM_dEf_gamH0(CSfdown,CPfdown,me,-1d0,dAMM_gamH0_e)
      dAMM_one_e=resAMM_e(1)+resAMM_e(2)+resAMM_e(3)+resAMM_e(4)+resAMM_e(5)
      dAMM_two_e=dAMM_gamH0_e(1)+dAMM_gamH0_e(2)
     &          +dAMM_gamH0_e(3)+dAMM_gamH0_e(4)
     &          +(-4*alpha)*dAMM_one_e*Log(Qs/me)
c#ifdef aaa 
      open(unit=46,file=slhafile,status="old",position="append",action='write')
      write(46,51) 'BLOCK AMM'
      write(46,51) '# SUSY contributions to the Anomalous Magnetic Moment (AMM)'
      write(46,53) 1,0,dAMM_one_e+dAMM_two_e,
     .     'electron AMM'
      if(AMMswitch.eq.2) then
      write(46,51) '# individual contributions to  the electron AMM'
c      write(46,53) 1,1,resAMM_e(1),'electron, one-loop W-boson contribution'
      write(46,53) 1,1,resAMM_e(2),'electron, one-loop Higgs contribution'
      write(46,53) 1,2,resAMM_e(3),'electron, one-loop neutralion contribution'
      write(46,53) 1,3,resAMM_e(4),'electron, one-loop chargino contribution'      
      write(46,53) 1,4,resAMM_e(5),'electron, one-loop charged Higgs contribution'
      write(46,53) 1,5,(-4*alpha)*dAMM_one_e*Log(Qs/mmu), 'electron, two-loop QED contribution'
      write(46,53) 1,6,dAMM_gamH0_e(1), 'electron, two-loop gammaH - q,tau contributions'
      write(46,53) 1,7,dAMM_gamH0_e(2), 'electron, two-loop gammaH - sq,stau contributions'  
      write(46,53) 1,8,dAMM_gamH0_e(3), 'electron, two-loop gammaH - chargino contributions' 
      write(46,53) 1,9,dAMM_gamH0_e(4), 'electron, two-loop gammaH - charged-Higgs contributions'               
      end if    
      write(46,51) '#'          
      write(46,53) 2,0,dAMM_one_m+dAMM_two_m,
     .     'muon AMM'

      write(46,51) '#'
      if(AMMswitch.eq.2) then
      write(46,51) '# individual contributions to the muon AMM'
c      write(46,53) 2,1,resAMM_m(1),'muon, one-loop W-boson contribution'
      write(46,53) 2,1,resAMM_m(2),'muon, one-loop Higgs contribution'
      write(46,53) 2,2,resAMM_m(3),'muon, one-loop neutralion contribution'
      write(46,53) 2,3,resAMM_m(4),'muon, one-loop chargino contribution'      
      write(46,53) 2,4,resAMM_m(5),'muon, one-loop charged Higgs contribution'
      write(46,53) 2,5,(-4*alpha)*dAMM_one_m*Log(Qs/mmu), 'muon, two-loop QED contribution'
      write(46,53) 2,6,dAMM_gamH0_m(1), 'muon, two-loop gammaH - q,tau contributions'
      write(46,53) 2,7,dAMM_gamH0_m(2), 'muon, two-loop gammaH - sq,stau contributions'  
      write(46,53) 2,8,dAMM_gamH0_m(3), 'muon, two-loop gammaH - chargino contributions' 
      write(46,53) 2,9,dAMM_gamH0_m(4), 'muon, two-loop gammaH - charged-Higgs contributions' 
      write(46,51) '#'
      end if

    
      close(46) 
c#endif
      
 51   format(A)
 53   format(1x,I2,1x,I2,3x,1P,E16.8,0P,3x,'#',1x,A)
      return
      end
      


c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      subroutine AMM_dEf_one(init,resAMM,resEDM)
      implicit none
      
      integer init,fin,i6,i5
c     init are ID of the initial and final lepton
c     ID = 1 for e, 2 for mu, 3 for tau
      
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision ZH5(5,5),ZH(6,6)
      double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
      double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3)
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
      common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe

      double precision absM1, absM2, absAu(3), absAd(3), absAe(3),  
     &                 ml2(3), mer2(3), mq2(3), mdr2(3), mur2(3)      
      common /softbreak/ absM1, absM2, absAu, absAd, absAe,  
     &                   ml2, mer2, mq2, mdr2, mur2 
      
      integer i3,i2,j2,i9,i,j
      double complex aHL,aHR,aNeuL,aNeuR,aChaL,aChaR,aHpmL,
     & aHpmR,aHSML,aHSMR
      double precision VGF,AMMC0,AMMC1,anC0,anC1,anC11  
      double precision AMMC11,resAMM(5),resEDM(5)    
      double precision MF2,afac,MH2
      double precision MF,aL1L,aL1R
      complex*16 fac1
#include "HdecayTCLs.inc"
      pi= 4d0*atan(1d0)
      sqrt2=dsqrt(2d0)
      MassFe(1) = me
      MassFe(2) = mmu
      MassFe(3) = mtau
      SW=Sqrt(1- MW**2/MZ**2) 

      fin=init
      MF=MassFe(init)      
      MF2=MF**2
      MSE2=MSE**2
      MCha2=MCha**2

      MNeu=Mchi
      MNeu2=MNeu**2
      SB=sin(beta)
      SB2= SB**2
      CB=Sqrt(1d0-sb2)

c      vGF= 1./sqrt(Gf*sqrt(2d0))
       vGF=v
                          
       MH2=125D0**2
       anC1=AMMC1(MF2,MH2,MF2)
       anC11=AMMC11(MF2,MH2,MF2)           
       aHSML=((4*anC1+3*anC11)*sqrt2*g2**2/8d0/MW2*MF**4)/(4d0*Pi**2*Sqrt2)
       aHSMR=((4*anC1+3*anC11)*sqrt2*g2**2/8d0/MW2*MF**4)/(4d0*Pi**2*Sqrt2)              

       aHL=0D0
       aHR=0D0
       do i6=2,6
       Masshh2(i6)=MH(i6-1)**2
       anC1=AMMC1(MF2,Masshh2(i6),MF2)
       anC11=AMMC11(MF2,Masshh2(i6),MF2)
       aHL=aHL+(MF**4*(CB*ZH(i6,1)-SB*ZH(i6,2)+IC*ZH(i6,4))*(-
     &  4*IC*anC1*ZH(i6,4)+3*anC11*
     &  (CB*ZH(i6,1)-SB*ZH(i6,2)-IC*ZH(i6,4))))/(16d0*CB**2*vGF**2*Pi**
     &  2)
       aHR=aHR+(MF**4*(CB*ZH(i6,1)-SB*ZH(i6,2)-IC*ZH(i6,4))*
     &  (4*IC*anC1*ZH(i6,4)+3*anC11*
     &  (CB*ZH(i6,1)-SB*ZH(i6,2)+IC*ZH(i6,4))))/(16d0*CB**2*vGF**2*Pi**
     &  2)     
       enddo

       aNeuL=0D0
       aNeuR=0D0
       do i5=1,5
       do i6=1,6
       anC0= AMMC0(MF2,MNeu2(i5),MSE2(i6))
       anC1= AMMC1(MF2,MNeu2(i5),MSE2(i6))       
       anC11= AMMC11(MF2,MNeu2(i5),MSE2(i6))  
       aNeuL=aNeuL+(-((2*anC1+3*anC11)*MF**2*(cchitaustauL(i5,init,i6)*
     &  DCONJG(cchitaustauL(i5,init,i6))+cchitaustauR(i5,init,i6)*
     &  DCONJG(cchitaustauR(i5,init,i6))))/(16d0*Pi**2)+((anC0+2*anC1)*
     &  MF*cchitaustauL(i5,init,i6)*DCONJG(cchitaustauR(i5,init,i6))*
     &  MNeu(i5))/(8d0*Pi**2))     
       aNeuR=aNeuR+(-((2*anC1+3*anC11)*MF**2*(cchitaustauL(i5,init,i6)*
     &  DCONJG(cchitaustauL(i5,init,i6))+cchitaustauR(i5,init,i6)*
     &  DCONJG(cchitaustauR(i5,init,i6))))/(16d0*Pi**2)+((anC0+2*anC1)*
     &  MF*cchitaustauR(i5,init,i6)*DCONJG(cchitaustauL(i5,init,i6))*
     &  MNeu(i5))/(8d0*Pi**2))      
       enddo
       enddo
      do i3=1,3,1
        MSv2(i3)=((g1**2 + g2**2)*vGF**2*Cos(2*beta) + 8*ml2(i3))/8.
      end do
       aChaL=0D0
       aChaR=0D0
       do i3=1,3
       do i2=1,2
       anC1= AMMC1(MF2,MSv2(i3),MCha2(i2))       
       anC11= AMMC11(MF2,MSv2(i3),MCha2(i2))        
       aChaL=aChaL+(((2*anC1+3*anC11)*MF**2*(ctauchastauL(init,i2,i3)*
     &  DCONJG(ctauchastauL(init,i2,i3))+ctauchastauR(init,i2,i3)*
     &  DCONJG(ctauchastauR(init,i2,i3))))/(16d0*Pi**2)+(anC1*MF*
     &  ctauchastauL(init,i2,i3)*DCONJG(ctauchastauR(init,i2,i3))*
     &  MCha(i2))/(4d0*Pi**2))
       aChaR=aChaR+(((2*anC1+3*anC11)*MF**2*(ctauchastauL(init,i2,i3)*
     &  DCONJG(ctauchastauL(init,i2,i3))+ctauchastauR(init,i2,i3)*
     &  DCONJG(ctauchastauR(init,i2,i3))))/(16d0*Pi**2)+(anC1*MF*
     &  ctauchastauR(init,i2,i3)*DCONJG(ctauchastauL(init,i2,i3))*
     &  MCha(i2))/(4d0*Pi**2))

       enddo
       enddo                  


       MHP2=MHpm**2    
       aHpmL=0D0
       aHpmR=0D0
       anC1=AMMC1(MF2,0D0,MHp2)  
       anC11=AMMC11(MF2,0D0,MHp2)       
       aHpmL=aHpmL-((anC1+(3*anC11)/2d0)*MF**2*CtaunuHpR(init,2)**2)
     &  /(8d0*Pi**2)
       aHpmR=aHpmR-((anC1+(3*anC11)/2d0)*MF**2*CtaunuHpR(init,2)**2)
     &  /(8d0*Pi**2)
c       print*, "aHpmL+aChaL+aNeuL+aHL-aHSML",aHpmL,aChaL,aNeuL,aHL,aHSML
       aL1L= aHpmL+aChaL+aNeuL+aHL-aHSML
       aL1R= aHpmR+aChaR+aNeuR+aHR-aHSMR                
       resAMM(1)=0D0
       resEDM(2)=0D0       
       resAMM(2)=DBLE(aHL-aHSML)
       resEDM(2)=1d0/(2*MF)*DIMAG(aHL-aHSML)   
          !without e factor to be consistent with EDM conventions of output  
       resAMM(3)=DBLE(aNeuL)
       resEDM(3)=1D0/(2*MF)*DIMAG(aNeuL)    
       resAMM(4)=DBLE(aChaL)
       resEDM(4)=1D0/(2*MF)*DIMAG(aChaL)      
       resAMM(5)=DBLE(aHpmL)
       resEDM(5)=1D0/(2*MF)*DIMAG(aHpmL)                
      return

      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      Barr-Zee-type contributions                                    c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine AMM_dEf_gamH0(CSf,CPf,mf,Qf,dEf_gamH0)
      implicit none
      
      double precision CSf(5),CPf(5),mf,Qf
      double precision dEf_gamH0(4)
      
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double complex CLChiFeSe(5,2),CRChiFeSe(5,2),CLChiFdSd(5,4),
     &               CRChiFdSd(5,4),CLChiFuSu(5,2),CRChiFuSu(5,2),
     &               ChStauStau(5,2,2),ChSbSb(5,2,2),ChStSt(5,2,2),
     &               CShChaCha(5,2,2),CPhChaCha(5,2,2)
      double precision CSfdown(5),CPfdown(5),CSfup(5),CPfup(5)
      double complex  CPHpChiCha(5,2),CSHpChiCha(5,2),CLWChiCha(5,2),
     &                 CRWChiCha(5,2),CPHpud(2),CSHpud(2),CSHpve,CPHpve 
      double complex CLChaFdSu(2,4),CRChaFdSu(2,4),CLChaFuSd(2,2),
     &               CRChaFuSd(2,2),CLChaFeSv(2),CRChaFeSv(2),
     &               CLdFgSd(2),CRdFgSd(2),CRuFgSu(2),CLuFgSu(2),
     &               CLbFgSb(2),CRbFgSb(2),CRtFgSt(2),CLtFgSt(2),
     &               CLsFgSs(2),CRsFgSs(2)
      
      double precision Qq(2),msq(2,2),mq(2)
      double complex Chsqsq(2,5,2,2),CSq(2,5),CPq(2,5)
      double precision x(5,2),y(5)
      
      double precision FUNC_EDM,fFUNC_EDM,gFUNC_EDM
      
      double complex part1,part2,part3,part4,part5,part6,partSM
      double precision sw,x1
      integer q,h,i,j
      double precision pi
      parameter (pi = 2d0*Asin(1d0))
      
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common/ couplingsEDM / CLChiFeSe,CRChiFeSe,CLChiFdSd,CRChiFdSd,
     &                       CLChiFuSu,CRChiFuSu,ChStauStau,ChSbSb,
     &                       ChStSt,CShChaCha,CPhChaCha,CSHpChiCha,
     &                       CPHpChiCha,CLWChiCha,CRWChiCha,
     &                       CSfdown,CPfdown,CSfup,CPfup,
     &                       CPHpud,CSHpud,CSHpve,CPHpve,
     &                       CLChaFdSu,CRChaFdSu,CLChaFuSd,CRChaFuSd,
     &                       CLChaFeSv,CRChaFeSv,CLdFgSd,CRdFgSd,
     &                       CRuFgSu,CLuFgSu,CLbFgSb,CRbFgSb,
     &                       CRtFgSt,CLtFgSt,CLsFgSs,CRsFgSs

      double complex  ChHcHc(5)
      common/ couplingsAMM /ChHcHc      

            
      Qq(1)=2d0/3d0
      Qq(2)=-1d0/3d0
      mq(1)=mt
      mq(2)=mb
      
      do i=1,2
      msq(1,i)=MSu(i+4)
      msq(2,i)=MSd(i+4)
      end do
      do h=1,5
      do i=1,2
      do j=1,2
      Chsqsq(1,h,i,j)=ChStSt(h,i,j)
      Chsqsq(2,h,i,j)=ChSbSb(h,i,j)
      end do
      end do
      end do
      
      do h=1,5
      CSq(1,h)=CSfup(h)
      CSq(2,h)=CSfdown(h)
      CPq(1,h)=CPfup(h)
      CPq(2,h)=CPfdown(h)
      end do
      part1=0d0
      do q=1,2
        do h=1,5
          do i=1,2
          x(h,i)=msq(q,i)**2/Mh(h)**2
          part1=part1+3d0*alpha*Qq(q)**2*mf**2*(CSf(h))*Chsqsq(q,h,i,i)*
     &          FUNC_EDM(x(h,i))/16d0/pi**3/Mh(h)**2
          end do
        end do
      end do
      
      sw=Sqrt(1-MW**2/MZ**2)
      part2=0d0
      do q=1,2
      do h=1,5
      x(h,q)=mq(q)**2/Mh(h)**2
      part2=part2+3d0*alpha**2*Qq(q)**2*mf**2*
     &     (CSf(h)*CSq(q,h)*fFUNC_EDM(x(h,q)) -
     &      CPf(h)*CPq(q,h)*gFUNC_EDM(x(h,q)))/
     &      4d0/pi**2/sw**2/Mw**2
      end do
      end do
      
      part3=0d0
      do h=1,2
      do i=1,2
      x(h,i)=MSe(i+4)**2/Mh(h)**2
      part3=part3+alpha*mf**2*CSf(h)*ChStauStau(h,i,i)*
     &      FUNC_EDM(x(h,i))/16d0/pi**3/Mh(h)**2
      end do
      end do
      
      part4=0d0
      do h=1,5
      y(h)=mtau**2/Mh(h)**2
      part4=part4+alpha**2*mf**2*(CSf(h)*CSfdown(h)*fFUNC_EDM(y(h))-
     &      CPf(h)*CPfdown(h)*gFUNC_EDM(y(h)))/
     &      40/pi**2/sw**2/Mw**2
      end do
      

      part5=0d0
      do h=1,5
      do i=1,2
      x(h,i)=Mcha(i)**2/Mh(h)**2
      part5=part5+alpha**2*mf**2*  
     &     (CSf(h)*CShChaCha(h,i,i)*fFUNC_EDM(x(h,i))-
     &      CPf(h)*CPhChaCha(h,i,i)*gFUNC_EDM(x(h,i)))/
     &      2d0/sqrt(2d0)/pi**2/sw**2/Mw/Mcha(i)
      end do
      end do
      
      part6=0d0
      do h=1,5
      y(h)=MHpm**2/Mh(h)**2
      part6=part6+alpha*mf**2*  
     &     (CSf(h)*ChHcHc(h)*FUNC_EDM(y(h)))/
     &      16d0/pi**3/Mh(h)**2
      end do
      partSM=0D0
      do q=1,2
      x1=mq(q)**2/125D0**2
      partSM=partSM+3d0*alpha**2*Qq(q)**2*mf**2*
     &     (fFUNC_EDM(x1) )/4d0/pi**2/sw**2/Mw**2
      enddo
      
      x1=mtau**2/125D0**2
      partSM=partSM+alpha**2*mf**2*(fFUNC_EDM(x1)
     &     )/40/pi**2/sw**2/Mw**2
     
      dEf_gamH0(1)=(part2+part4)-partSM
      dEf_gamH0(2)=(part1+part3)
      dEf_gamH0(3)=(part5)      
      dEf_gamH0(4)=(part6)
!      print*, "squark",part1
!      print*, "quark",part2
!      print*, "stau",part3
!      print*, "tau",part4
!      print*, "chargino",part5
!      print*, "chargedHiggs",part6
!      print*, "SM",partSM
      return
      end
          
c ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      double precision function AMMC0(m2,x2,y2)  
      implicit none
      double precision m2,x2,y2,la12,Lambda12
      la12=Lambda12(m2,x2,y2)
      if (m2/x2.lt.1D-2 .and. m2/y2.lt.1D-2 )then
      AMMC0=(-(1./(-1 + y2/x2)) + Log(y2/x2)/(-1 + y2/x2)**2)/x2   
      return
      endif
      
      if(.not.isnan(la12) )then
      
       if (x2 .gt.1D-10)then
        if (abs(x2-y2).gt.1D-10)then
      AMMC0=Log(x2/y2)/(2.*m2) - ((m2 + x2 - y2)*Log((la12 - m2 + x2 + y2)
     &       /(2.*sqrt(x2*y2) )))/(la12*m2)
        else
      AMMC0=-((Sqrt(m2*(-m2 + 4*y2))*Log((-m2 + Sqrt(m2*(-m2 + 4*y2)) + 
     &  2*y2)/(2.*y2)))/(m2*(m2 - 4*y2)))
        endif    
        if(abs(m2-y2).lt.1D-10)then
      AMMC0= -Log(m2/x2)/(2.*m2) + (Sqrt(x2*(-4*m2 + x2))*
     -     Log((x2 + Sqrt(x2*(-4*m2 + x2)))/(2.*sqrt(m2*x2))))/(m2*(4*m2 - x2))  
        endif   
        If(abs(x2-m2).lt.1D-10)then
        AMMC0=Log(m2/y2)/(2.*m2) + ((2*m2 - y2)*Sqrt(y2*(-4*m2 + y2))*
     -     Log((y2 + Sqrt(y2*(-4*m2 + y2)))/(2.*Sqrt(m2)*Sqrt(y2))))/
     -   (m2*(4*m2 - y2)*y2)
        endif   
       else
       AMMC0= -(Log(y2/(-m2 + y2))/m2)
       endif
      else
      
      AMMC0=(-(1./(-1 + y2/x2)) + Log(y2/x2)/(-1 + y2/x2)**2)/x2     
      endif
      end  

c ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      double precision function AMMC1(m2,x2,y2)
      implicit none 
      double complex myB0,part1
      double precision m2,x2,y2,la12,Lambda12,AMMC0   
      double precision CFUNC_AMM1
      double precision ratio1,ratio2,p2,m12,m22
      double precision res,rel      
      integer ivegas(4),iprint      
      external CFUNC_AMM1
      common/inpVEGAS/ivegas,iprint        
      common/FUNCAMM/p2,m12,m22         
      if (x2*y2.gt.1D-10)then  
      ratio1=m2/y2;ratio2= m2/x2
        if(ratio1 .lt. 1D-2 .AND. ratio2 .lt. 1D-2 )then  
      AMMC1=((-3. + y2/x2)/(4.*(-1 + y2/x2)**2) + Log(y2/x2)/(2.*(-1. 
     -        + y2/x2)**3))/x2      
        return         
        else
        goto 9
        endif
      else
      goto 9   
      endif
9     continue
        p2=m2; m12=x2;m22=y2
        call INTEG(CFUNC_AMM1,1,iprint,ivegas,res,rel)    
        AMMC1=res 
      return
      end
      
      double precision function CFUNC_AMM1(t)
      
      implicit none
      
      double precision t,m2,x2,y2
      common/FUNCAMM/m2,x2,y2      
      if(t.eq.0) then
      CFUNC_AMM1=0
      else
      CFUNC_AMM1=-t**2/(2.*(-(m2*t**2) - x2 + t*(m2 + x2 - y2)))
      end if
      
      return
      end  
      

c ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      double precision function AMMC11(m2,x2,y2)
      implicit none 
      double complex myB1,part1
      double precision m2,x2,y2,la12,Lambda12,AMMC1N,AMMC0 
      double precision ratio1,ratio2,p2,m12,m22
      double precision res,rel
      double precision CFUNC_AMM11
      integer ivegas(4),iprint      
      external CFUNC_AMM11
      common/inpVEGAS/ivegas,iprint        
      common/FUNCAMM/p2,m12,m22           
      if (x2*y2.gt.1D-10)then  
      ratio1=m2/y2;ratio2= m2/x2
        if(ratio1 .lt. 1D-2 .AND. ratio2 .lt. 1D-2 )then    
      AMMC11=((-11. + (7*y2)/x2 - (2.*y2**2)/x2**2)/(18.*(-1 + y2/x2)**3) 
     &            + Log(y2/x2)/(3.*(-1. + y2/x2)**4))/x2 
        return
        else
        goto 10
        endif
      else
      goto 10    
      endif
10    continue
        p2=m2; m12=x2;m22=y2
        call INTEG(CFUNC_AMM11,1,iprint,ivegas,res,rel)    
        AMMC11=res         
      return
      end 
      
      double precision function CFUNC_AMM11(t)
      
      implicit none
      
      double precision t,m2,x2,y2
      common/FUNCAMM/m2,x2,y2      
      if(t.eq.0) then
      CFUNC_AMM11=0
      else
      CFUNC_AMM11=t**3/(3.*(-(m2*t**2) - x2 + t*(m2 + x2 - y2)))
      end if
      
      return
      end           
       
*
***********************************************************************
*
      double precision function Lambda12(x,y,z)
      double precision x,y,z
       Lambda12=sqrt(x**2+y**2+z**2-2*x*y-2*x*z-2*y*z)

      end  
      

  

