c######################################################################
      subroutine ReHSelf_QCD()
      implicit none
      integer i,j,k,l,ischeme,izerodv1
      double precision renfin(5,5),regfac,reself(5,5),MHp2
      double precision MW2,MZ2, A0k,pi,ass
      double precision absM3, phiM3      
      double precision Qs
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
     
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double precision ZH5(5,5),ZH(6,6)
     
      double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
      
      double complex nZU(6,6)
      
      double precision nMSu(6)
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
      double precision absM1, absM2, absAu(3), absAd(3), absAe(3),  
     &                 ml2(3), mer2(3), mq2(3), mdr2(3), mur2(3)      
      double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3)
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      logical CPcon,MHpmInput,onelswitch,mQrun

      double complex IC,ZUN(2,2),AT,la,Ala,ka,Aka,MUE,expETA,expVS,expM3
      common /gluino/ absM3,phiM3      
      common /scale/ Qs
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU
      common /nSu/ nMSu,nZU
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
      common /softbreak/ absM1, absM2, absAu, absAd, absAe,  
     &                   ml2, mer2, mq2, mdr2, mur2
      common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common /switch/ MHpmInput,CPcon,mQrun,onelswitch
      IC=dcmplx(0,1D0)
      ZUN(1:2,1:2) = nZU(5:6,5:6)
      MW2=Mw**2; MZ2=Mz**2;MHp2=MHpm**2
      Ala= absAlambda*(cos(phiAl) + IC*Sin(phiAl))
      AT= absAu(3)*(cos(phiAu(3)) + IC*Sin(phiAu(3)))
      la= abslambda*(Cos(phil) + IC*Sin(phil))
      ka= abskappa*(Cos(phik) + IC*Sin(phik))
      Aka=absAkappa*(Cos(phiAk) + IC*Sin(phiAk))
      expvs=(Cos(phis) + IC*Sin(phis))
      expETA=(Cos(phiu) + IC*Sin(phiu))
      MUE=vs*la*expvS/dsqrt(2d0)
      expM3=sqrt((Cos(phiM3) + IC*Sin(phiM3)) )
      pi= 4D0*atan(1D0)
      ass=g3**2/4./pi
      if(mQrun)then
        ischeme=1
      else
        ischeme=3
      endif
       
      call selfHH_QCD(Qs**2,ass,mt,nMSu(5),nMSu(6),ZUN,absM3,
     -   la,ka, Aka,Ala,AT,v,vS,Tanb,expM3,expETA,expvS,ZH,MW2,MZ2,MHp2,
     -   reself,MHpmInput,ischeme,izerodv1)

      do i=1,5
      do j=1,5
      renfin(i,j) =0D0
       do k=1,5
       do l=1,5
      renfin(i,j) = renfin(i,j)+ZH5(i,k)*ZH5(j,l)*reself(k,l)
       enddo
       enddo
      enddo
      enddo
#ifdef printMT4
      write(*,*) "===================================================="
      write(*,*) "ZH5(1,1:5)", ZH5(1,1:5)
      write(*,*) "ZH5(2,1:5)", ZH5(2,1:5)
      write(*,*) "ZH5(3,1:5)", ZH5(3,1:5)
      write(*,*) "ZH5(4,1:5)", ZH5(4,1:5)
      write(*,*) "ZH5(5,1:5)", ZH5(5,1:5)
      write(*,*) " atlambda contributions in basis (a1,a2,h1,h2,h3)"
      write(*,*) "renfin(1,1:5)=",renfin(1,1:5)   
      write(*,*) "renfin(2,1:5)=",renfin(2,1:5)
      write(*,*) "renfin(3,1:5)=",renfin(3,1:5)     
      write(*,*) "renfin(4,1:5)=",renfin(4,1:5) 
      write(*,*) "renfin(5,1:5)=",renfin(5,1:5) 
#endif
      end subroutine ReHSelf_QCD
c######################################################################


      subroutine selfHH_QCD(Q2N,assN,MTN,MSt1,MST2,ZUN,mg,laN,kappaN,
     .   Akappa,Alambda,ATTN,vvN,vvS,ttb,expM3N,expETAN,expVSN
     .   ,ZHH,MW2N,MZ2N,MHpm2,ReSelf,MHpmInput,RTOPSCHEME,Zerodv1)
      implicit none
      integer i,j,k,i1, i2, i3,l1,Gen3,Gen4,Gen5,Gen6,
     .   RTOPSCHEME, zerodv1  

      double precision Q2N,assN,MTN,MSt1,MST2,mg,vvN,ttb,vvS,ZHH(6,6),
     .        reself(5,5),ReSelfIN(6,6),MW2n,MZ2n
      double complex expM3N,expVSN,expETAN,ZUN(2,2),ATTN
      double complex  Akappa,laN,kappaN,Alambda      

      double precision dmsq4fin,dmsur4fin
      double complex dAt4fin     
      double precision mah(6),mah2(6),cosphix,cosphiz,
     .         sinphix,sinphiz,MHpm2,MHp2N,RAlambda,
     .         IAlambda,cosk3s,sink3s
      double complex expAka,expAla,expkap,explam,MassH(6,6),ZHN(6,6),
     .         AlaC
#include "TLQCDN.h"

      double precision CHself(2,2)
      double complex selfHH(6,6),SelfZ,selfW
    
      logical MHpmInput


      expVS= expVSN;   expETA=expETAN;  vv= vvN; expM3=expM3N   

      ass=assN;        Q2=Q2N;       
      pi= 3.1415926535897932384626433832795029D0
      ZetaN2= pi**2/6D0
      M1= MTN;    M2= Mst1;   M3= mg;     M4= Mst2;
      M12= M1**2; M22= M2**2; M32= M3**2; M42=M4**2   
      sqrt2=dSqrt(2D0);        vS = vvS
      TB=ttb; 	       TB2= TB**2;	CB2 = 1/(1 + TB2)
      SB2 = CB2*TB2;	       CB = sqrt(CB2);	SB = CB*TB
      S2B = 2*TB*CB2;          C2B= (CB - SB)*(CB + SB)
      la=laN; kappa=kappaN; Aka=Akappa;Ala=Alambda
      AT = ATTN; MUE= la*vs*expVS/sqrt2
      ZU=ZUN
      MSQ2=-M12 + M22*ZU(1,1)*DCONJG(ZU(1,1)) + M42*ZU(2,1)*DCONJG(ZU(2,1))      
      MassSu(1)=M2; MassSU(2)=M4
      MassSu2(1)=M22; MassSU2(2)=M42

      IC=(0,1D0)
      
      vv2=vv**2; vS2=vS**2
      abslambda = abs(la); la2=abslambda**2;laC=DCONJG(la)
      abskappa=abs(kappa); ka2=abskappa**2
      if (abslambda.gt.1D-10)then
      explam=la/abslambda
      else
      explam=1D0
      endif

      if (abskappa.gt.1D-10)then
      expkap=kappa/abskappa
      else
      expkap=1D0
      endif

      absAkappa=abs(Aka)
      if (absAkappa.gt.1D-10)then
      expAka = Aka/absAkappa
      else
      expAka=1D0
      endif

      cosphiy = DBLE(expETA/expVS**(2)/expkap*explam)
      sinphiy = DIMAG(expETA/expVS**(2)/expkap*explam)
      cosk3s= DBLE(expkap*expVS**3)
      sink3s= DIMAG(expkap*expVS**3)
      sign2 =DBLE(expVS*expAka*expkap)/abs(DBLE(expVS*expAka*expkap))

      if (MHpmInput)then

        MHp2N=MHpm2
       
        RAlambda=(-4*abskappa*abslambda*vs**2*cosk3s + 
     -      (4*(MHp2N) + (2*abslambda**2 )*vv2)
     -      * DBLE(expVS*expETA*explam)*S2B)/
     -      (4.*Sqrt2*abslambda*vs)

        IAlambda=(abskappa*vs/DBLE(expVS*expETA*explam)*
     -        DIMAG(expVS**(2)*expkap/explam/expETA))/Sqrt2 
     -       - RAlambda*DIMAG(expVS*expETA*explam)/DBLE(expVS*expETA*explam)  


        Ala=RAlambda +IC*IAlambda 
      sign1 =  DBLE(expETA*expVS*Ala/abs(Ala)*explam)
     -    /abs(DBLE(expETA*expVS*Ala/abs(Ala)*explam))
      else
      sign1 =  DBLE(expETA*expVS*Ala/abs(Ala)*explam)
     -    /abs(DBLE(expETA*expVS*Ala/abs(Ala)*explam))
      sinphix =-((abskappa*Sinphiy*vS)/(abs(Ala)*sqrt2))
      sinphix =-((abskappa*Sinphiy*vS)/(abs(Ala)*sqrt2))
      sinphiz =(abslambda*CB*SB*(abs(Ala)*Sinphix*sqrt2 
     -  - 2*abskappa*Sinphiy*vS)*vv2)/(absAkappa*abskappa*sqrt2*vs2)

      Cosphix = Sign1*Sqrt(1D0- Sinphix**2)
      Cosphiz = Sign2*Sqrt(1D0- Sinphiz**2)

      MHp2N= (Abs(Ala)*abslambda*Cosphix*vS)/(CB*SB*sqrt2)+ 
     -     (abskappa*abslambda*Cosphiy*vs2)/(2.*CB*SB) - (la2*vv2)/2D0

      endif
      MHp2=MHp2N
      AlaC=DCONJG(Ala)
      absAlambda= Abs(Ala)
      if (absAlambda.gt.1D-10)then
      expAla = Ala/absAlambda
      else
      expAla=1D0
      endif
      sqrt1x=  Sqrt(2D0-0*(9*abslambda**2*CB2*SB2*Sinphiy**2*
     -      vv**4)/(absAkappa**2*vS2))
      sqrt2x= Sqrt(2D0 - (ka2*Sinphiy**2*vS2)/absAlambda**2)


      MassH(1,1)=MHp2*SB2  + (la2*SB2*vv2)/2.
      MassH(1,2)=(CB*SB*(-2*MHp2 + la2*vv2))/2.
      MassH(1,3)=-((CB*MHp2*SB2*vv)/vS)  + CB*la2*vS*vv
     -  -(abskappa*abslambda*Cosphiy*SB*vS*vv)/2.
     -  - (CB*la2*SB2*vv**3)/(2.*vS)
      MassH(1,4)=0D0;
      MassH(1,5)=(-3*abskappa*abslambda*SB*Sinphiy*vS*vv)/2.
      MassH(1,6)=0D0
      MassH(2,2)=CB2*MHp2 +(CB2*la2*vv2)/2.
      MassH(2,3)= -((CB2*MHp2*SB*vv)/vS)  - 
     -  (abskappa*abslambda*CB*Cosphiy*vS*vv)/2. + 
     -  la2*SB*vS*vv - (CB2*la2*SB*vv**3)/(2.*vS)
      MassH(2,4)=0D0
      MassH(2,5)=(-3*abskappa*abslambda*CB*Sinphiy*vS*vv)/2.
      MassH(2,6)=0D0
      MassH(3,3)=2*ka2*vs2 + (CB2*la2*SB2*vv**4)/(2.*vS2) + 
     -  (absAkappa*abskappa*sign2*vS*Sqrt(1D0 - 
     -  (9*CB2*la2*SB2*Sinphiy**2*vv**4)/(2.*absAkappa**2*vS2)))/sqrt2- 
     -  (abskappa*abslambda*CB*Cosphiy*SB*vv2)/2. + 
     -  (CB2*MHp2*SB2*vv2)/vS2 
      MassH(3,4)=(abskappa*abslambda*Sinphiy*vS*vv)/2.
      MassH(3,5)=2*abskappa*abslambda*CB*SB*Sinphiy*vv2
      MassH(3,6)=0D0
      MassH(4,4)=(2*MHp2 + la2*vv2)/2.
      MassH(4,5)= (vv*(-3*abskappa*abslambda*Cosphiy*vS**2 + 
     -      CB**3*SB*(2*MHp2 + la2*vv**2) + CB*SB**3*
     -     (2*MHp2  + la2*vv**2)))/(2.*vS)
      MassH(4,6)=0D0
      MassH(5,5)=(-3*absAkappa*abskappa*sign2*vS*vS2*
     -     Sqrt(4 - (18*CB2*la2*SB2*Sinphiy**2*vv**4)/(absAkappa**2*vS2)) + 
     -    3*abskappa*abslambda*CB*Cosphiy*SB*sqrt2*vS2*vv2 + 
     -    CB2*SB2*sqrt2*(la2*vv**4 + 2*(MHp2 )*vv2))/(2.*sqrt2*vS2)
      MassH(5,6)=0D0
      MassH(6,6)=0D0        
      MassH(2,1)=MassH(1,2)
      MassH(3,1)=MassH(1,3)
      MassH(3,2)=MassH(2,3)
      MassH(4,1)=MassH(1,4)
      MassH(4,2)=MassH(2,4)
      MassH(4,3)=MassH(3,4)
      MassH(5,1)=MassH(1,5)
      MassH(5,2)=MassH(2,5)
      MassH(5,3)=MassH(3,5)
      MassH(5,4)=MassH(4,5)
      MassH(6,1)=MassH(1,6)
      MassH(6,2)=MassH(2,6)
      MassH(6,3)=MassH(3,6)
      MassH(6,4)=MassH(4,6)
      MassH(6,5)=MassH(5,6)

      call HEIgensystem(5, MassH(1:5,1:5),5, Mah2(1:5), ZHN(1:5,1:5),5, 1)
      do i=1,5
        if (mah2(i).lt.0D0 .or. mah2(i).ne.mah2(i) ) then
        print*, '* Warning!! Negative or NAN Higgs mass Eigenvalues!! in the gaugeless limit'
        print*, "MH_1^2=",mah2(i)
        print*, 'Return to the option 6  3 in Block MODSEL of input file'   
        print*, 'that include O(alpha_t alpha_s + alpha_t^2) correction'
        stop
        else 
        Mah(i) = Sqrt(mah2(i))
        endif
      enddo

        Mah(6)=0  
      do i=1,5
        ZHN(i,6)=ZHN(i,5)
        ZHN(i,5)= CB*ZHN(i,4)
        ZHN(i,4)= SB*ZHN(i,4)
      enddo
        ZHN(6,6)=0; ZHN(6,5)=-SB; ZHN(6,4)= CB
        ZH(1:6,1:6)=DBLE(ZHN(1:6,1:6))
 
c loop integrals
      
      print*, "I am here"
      call LIBLOOP_QCD
      
      print*, "I am here"

c **************
c couplings
c      print*, "couplings"
      call TLcouplings_QCD
            print*, "I am here"
c **************
c one-loop counterterms

c      print*, "CT1loop_QCD"
      call CT1loop_QCD(RTOPSCHEME,dmsq4fin,dmsur4fin,dAt4fin,MHpminput)
            print*, "I am here,MHpmInput",MHpmInput
c **************
c CT couplings  
c            print*, "TLCTcouplings_QCD"     
      call TLCTcouplings_QCD  
         print*, "I am here5"
         
      call TLTad_QCD(tadiH2)  
      print*, "tadpole",tadiH2(1:6)
      
      call SelfTZZ_QCD(selfZ)
      call SelfTWW_QCD(selfW) 
      dvv2     = -CW**2/SW**2/2.*(selfW - selfZ)
     -             +1/2.*selfW
      print*, "dvv2",dvv2*vv             
c***************
c charged Higgs self
c            print*, "CHself_QCD"    
      call CHself_QCD(CHself,MHpmInput)      
       print*, "CHself,MHpmInput",CHself,MHpmInput
      call TLSeHH_QCD(selfHH)        
      end
